Unit Pal256tp;
Interface

Const
	PaletteGetPort  = $03C7;	{Palette Get Port}
	PaletteSetPort  = $03C8;	{Palette Set Port}
	PaletteDataPort = $03C9;	{Palette Data Port}

Type
{Palette data types}
	RGB = Record
		Red: 		Byte; {Red Value}
		Green: 	Byte; {Green Value}
		Blue: 	Byte; {Blue Value}
	End;{Declaration}
	Palette256 = array[0..255] of RGB; {Palette Type}

Procedure SetPaletteAtt(Att: Byte; Red, Green, Blue: Byte);
{Set Attribute}

Procedure GetPaletteAtt(Att: Byte; Var Red, Green, Blue: Byte);
{Get Attribute}

Procedure SetPalette(Var Pal: Palette256);
{Set VGA Palette}

Procedure GetPalette(Var Pal: Palette256);
{Get VGA Palette}

Implementation

Procedure SetPaletteAtt(Att: Byte; Red, Green, Blue: Byte);
{Set Attribute}
	Begin
		Port[PaletteSetPort] := Att;
		Port[PaletteDataPort] := Red;
		Port[PaletteDataPort] := Green;
		Port[PaletteDataPort] := Blue;
	End;{SetPaletteAtt}

Procedure GetPaletteAtt(Att: Byte; Var Red, Green, Blue: Byte);
{Get Attribute}
	Begin
		Port[PaletteGetPort] := Att;
		Red := Port[PaletteDataPort];
		Green := Port[PaletteDataPort];
		Blue := Port[PaletteDataPort];
	End;{GetPaletteAtt}

Procedure SetPalette(Var Pal: Palette256);
{Set VGA Palette}
	Var
		W: 	integer; 	{Counter}
	Begin
		Port[PaletteSetPort] := 0;
		For W := 0 to 255 do
			Begin
				Port[PaletteDataPort] := Pal[W].Red;
				Port[PaletteDataPort] := Pal[W].Green;
				Port[PaletteDataPort] := Pal[W].Blue;
			End;{For}
	End;{SetPalette}

Procedure GetPalette(Var Pal: Palette256);
{Get VGA Palette}
	Var
		W: 	integer; 	{Counter}
	Begin
		Port[PaletteGetPort] := 0;
		For W := 0 to 255 do
			Begin
				Pal[W].Red := Port[PaletteDataPort];
				Pal[W].Green := Port[PaletteDataPort];
				Pal[W].Blue := Port[PaletteDataPort];
			End;{For}
	End;{GetPalette}

End.